--- v2.4.5/linux/include/linux/inetdevice.h~	Sun Jul  1 11:05:50 2001
+++ linux/include/linux/inetdevice.h	Sun Jul  1 13:08:45 2001
@@ -18,6 +18,7 @@
 	int	mc_forwarding;
 	int	tag;
 	int     arp_filter;
+	int     forward_shared;
 	void	*sysctl;
 };
 
@@ -56,6 +57,8 @@
 	  (ipv4_devconf.accept_redirects || (in_dev)->cnf.accept_redirects)))
 
 #define IN_DEV_ARPFILTER(in_dev)	(ipv4_devconf.arp_filter || (in_dev)->cnf.arp_filter)
+
+#define IN_DEV_FORWARD_SHARED(in_dev)	((in_dev)->cnf.forward_shared && ipv4_devconf.forward_shared)
 
 struct in_ifaddr
 {
--- v2.4.5/linux/include/linux/sysctl.h~	Sun Jul  1 11:05:50 2001
+++ linux/include/linux/sysctl.h	Sun Jul  1 14:02:39 2001
@@ -325,7 +325,8 @@
 	NET_IPV4_CONF_BOOTP_RELAY=10,
 	NET_IPV4_CONF_LOG_MARTIANS=11,
 	NET_IPV4_CONF_TAG=12,
-	NET_IPV4_CONF_ARPFILTER=13
+	NET_IPV4_CONF_ARPFILTER=13,
+	NET_IPV4_CONF_FORWARD_SHARED=14,
 };
 
 /* /proc/sys/net/ipv6 */
--- v2.4.5/linux/net/ipv4/devinet.c~	Sun Jul  1 11:05:50 2001
+++ linux/net/ipv4/devinet.c	Sun Jul  1 12:30:43 2001
@@ -1016,7 +1016,7 @@
 static struct devinet_sysctl_table
 {
 	struct ctl_table_header *sysctl_header;
-	ctl_table devinet_vars[14];
+	ctl_table devinet_vars[15];
 	ctl_table devinet_dev[2];
 	ctl_table devinet_conf_dir[2];
 	ctl_table devinet_proto_dir[2];
@@ -1061,6 +1061,9 @@
 	 &proc_dointvec},
 	{NET_IPV4_CONF_ARPFILTER, "arp_filter",
 	 &ipv4_devconf.arp_filter, sizeof(int), 0644, NULL,
+	 &proc_dointvec},
+	{NET_IPV4_CONF_FORWARD_SHARED, "forward_shared",
+	 &ipv4_devconf.forward_shared, sizeof(int), 0644, NULL,
 	 &proc_dointvec},
 	 {0}},
 
--- v2.4.5/linux/include/net/ip_fib.h~	Sun Jul  1 11:04:32 2001
+++ linux/include/net/ip_fib.h	Sun Jul  1 14:11:54 2001
@@ -203,7 +203,7 @@
 extern int inet_rtm_getroute(struct sk_buff *skb, struct nlmsghdr* nlh, void *arg);
 extern int inet_dump_fib(struct sk_buff *skb, struct netlink_callback *cb);
 extern int fib_validate_source(u32 src, u32 dst, u8 tos, int oif,
-			       struct net_device *dev, u32 *spec_dst, u32 *itag);
+			       struct net_device *dev, u32 *spec_dst, u32 *itag, int our);
 extern void fib_select_multipath(const struct rt_key *key, struct fib_result *res);
 
 /* Exported by fib_semantics.c */
--- v2.4.5/linux/net/ipv4/fib_frontend.c~	Sun Jul  1 11:05:50 2001
+++ linux/net/ipv4/fib_frontend.c	Sun Jul  1 14:36:45 2001
@@ -204,13 +204,15 @@
  */
 
 int fib_validate_source(u32 src, u32 dst, u8 tos, int oif,
-			struct net_device *dev, u32 *spec_dst, u32 *itag)
+			struct net_device *dev, u32 *spec_dst, u32 *itag,
+			int our)
 {
 	struct in_device *in_dev;
 	struct rt_key key;
 	struct fib_result res;
 	int no_addr, rpf;
 	int ret;
+	int fwdsh = 0;
 
 	key.dst = src;
 	key.src = dst;
@@ -225,6 +227,7 @@
 	if (in_dev) {
 		no_addr = in_dev->ifa_list == NULL;
 		rpf = IN_DEV_RPFILTER(in_dev);
+		fwdsh = IN_DEV_FORWARD_SHARED(in_dev);
 	}
 	read_unlock(&inetdev_lock);
 
@@ -233,7 +236,12 @@
 
 	if (fib_lookup(&key, &res))
 		goto last_resort;
-	if (res.type != RTN_UNICAST)
+	if (fwdsh) {
+		fwdsh = (res.type == RTN_LOCAL && !our);
+		if (fwdsh)
+			rpf = 0;
+	}
+	if (res.type != RTN_UNICAST && !fwdsh)
 		goto e_inval_res;
 	*spec_dst = FIB_RES_PREFSRC(res);
 	if (itag)
@@ -254,6 +262,8 @@
 	if (rpf)
 		goto e_inval;
 	key.oif = dev->ifindex;
+	if (fwdsh)
+		key.iif = loopback_dev.ifindex;
 
 	ret = 0;
 	if (fib_lookup(&key, &res) == 0) {
--- v2.4.5/linux/net/ipv4/route.c~	Sun Jul  1 11:05:50 2001
+++ linux/net/ipv4/route.c	Sun Jul  1 11:07:09 2001
@@ -1206,7 +1206,7 @@
 			goto e_inval;
 		spec_dst = inet_select_addr(dev, 0, RT_SCOPE_LINK);
 	} else if (fib_validate_source(saddr, 0, tos, 0,
-					dev, &spec_dst, &itag) < 0)
+					dev, &spec_dst, &itag, our) < 0)
 		goto e_inval;
 
 	rth = dst_alloc(&ipv4_dst_ops);
@@ -1367,7 +1367,7 @@
 		int result;
 		result = fib_validate_source(saddr, daddr, tos,
 					     loopback_dev.ifindex,
-					     dev, &spec_dst, &itag);
+					     dev, &spec_dst, &itag, 1);
 		if (result < 0)
 			goto martian_source;
 		if (result)
@@ -1394,7 +1394,7 @@
 	}
 
 	err = fib_validate_source(saddr, daddr, tos, FIB_RES_OIF(res), dev,
-				  &spec_dst, &itag);
+				  &spec_dst, &itag, 0);
 	if (err < 0)
 		goto martian_source;
 
@@ -1478,7 +1478,7 @@
 		spec_dst = inet_select_addr(dev, 0, RT_SCOPE_LINK);
 	else {
 		err = fib_validate_source(saddr, 0, tos, 0, dev, &spec_dst,
-					  &itag);
+					  &itag, 1);
 		if (err < 0)
 			goto martian_source;
 		if (err)
--- v2.4.5/linux/Documentation/filesystems/proc.txt~	Sun Jul  1 11:05:03 2001
+++ linux/Documentation/filesystems/proc.txt	Sun Jul  1 14:28:21 2001
@@ -1561,6 +1561,18 @@
 (external addresses  can  still  be  spoofed), without the need for additional
 firewall rules.
 
+forward_shared
+--------------
+
+Integer value determines if a source validation should allow forwarding
+of packets with local source address. 1 means yes, 0 means no. By default
+the flag is disabled and such packets are not forwarded.
+
+If you enable this flag on internal network, the router will forward
+packets from internal hosts with shared IP addresses no matter how
+the rp_filter is set. This flag is activated only if it is enabled
+both in specific device section and in "all" section.
+
 secure_redirects
 ----------------
 
--- v2.4.5/linux/Documentation/networking/ip-sysctl.txt~	Sun Jul  1 11:05:34 2001
+++ linux/Documentation/networking/ip-sysctl.txt	Sun Jul  1 14:29:03 2001
@@ -347,6 +347,17 @@
 forwarding - BOOLEAN
 	Enable IP forwarding on this interface.
 
+forward_shared - BOOLEAN
+	Integer value determines if a source validation should allow
+	forwarding of packets with local source address. 1 means yes,
+	0 means no. By default the flag is disabled and such packets
+	are not forwarded.
+ 
+	If you enable this flag on internal network, the router will forward
+	packets from internal hosts with shared IP addresses no matter how
+	the rp_filter is set. This flag is activated only if it is
+	enabled both in specific device section and in "all" section.
+
 mc_forwarding - BOOLEAN
 	Do multicast routing. The kernel needs to be compiled with CONFIG_MROUTE
 	and a multicast routing daemon is required.